Bug 1289389 - python-pthreading tests fail on AArch64
python-pthreading tests fail on AArch64
Status: CLOSED CURRENTRELEASE
Product: Fedora
Classification: Fedora
Component: python-pthreading (Show other bugs)
27
aarch64 Linux
unspecified Severity unspecified
: ---
: ---
Assigned To: Dan Kenigsberg
Fedora Extras Quality Assurance
:
Depends On:
Blocks: ARMTracker 1336557
  Show dependency treegraph
 
Reported: 2015-12-07 20:18 EST by Yaakov Selkowitz
Modified: 2018-03-20 23:11 EDT (History)
12 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
: 1336557 (view as bug list)
Environment:
Last Closed: 2018-03-20 23:11:34 EDT
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Yaakov Selkowitz 2015-12-07 20:18:05 EST
python-pthreading tests fail on aarch64 with the output below.  As there is no architecture-specific code in python-pthreading, I believe the issue is in python itself.

*** Error in `/usr/bin/python': free(): invalid next size (fast): 0x000002ab0dd2a220 ***
======= Backtrace: =========
/lib64/libc.so.6(+0x70e80)[0x3ffafe80e80]
/lib64/libc.so.6(+0x7945c)[0x3ffafe8945c]
/lib64/libc.so.6(cfree+0x48)[0x3ffafe8c928]
/usr/lib64/python2.7/lib-dynload/_ctypes.so(+0x7738)[0x3ffaf977738]
/usr/lib64/python2.7/lib-dynload/_ctypes.so(+0x779c)[0x3ffaf97779c]
/lib64/libpython2.7.so.1.0(+0x9f4ec)[0x3ffb01af4ec]
/lib64/libpython2.7.so.1.0(+0x9e714)[0x3ffb01ae714]
/lib64/libpython2.7.so.1.0(+0x9f444)[0x3ffb01af444]
/lib64/libpython2.7.so.1.0(+0x9e714)[0x3ffb01ae714]
/lib64/libpython2.7.so.1.0(+0x9f444)[0x3ffb01af444]
/lib64/libpython2.7.so.1.0(+0x81b1c)[0x3ffb0191b1c]
/lib64/libpython2.7.so.1.0(+0x9f564)[0x3ffb01af564]
/lib64/libpython2.7.so.1.0(+0x559bc)[0x3ffb01659bc]
/lib64/libpython2.7.so.1.0(+0x6f110)[0x3ffb017f110]
/lib64/libpython2.7.so.1.0(PyEval_EvalCodeEx+0x4cc)[0x3ffb01f69d4]
/lib64/libpython2.7.so.1.0(PyEval_EvalFrameEx+0x58e0)[0x3ffb01f5fc0]
/lib64/libpython2.7.so.1.0(PyEval_EvalCodeEx+0x818)[0x3ffb01f6d20]
/lib64/libpython2.7.so.1.0(+0x709bc)[0x3ffb01809bc]
/lib64/libpython2.7.so.1.0(PyObject_Call+0x68)[0x3ffb015afa0]
/lib64/libpython2.7.so.1.0(PyEval_EvalFrameEx+0xc20)[0x3ffb01f1300]
/lib64/libpython2.7.so.1.0(PyEval_EvalCodeEx+0x818)[0x3ffb01f6d20]
/lib64/libpython2.7.so.1.0(+0x708c8)[0x3ffb01808c8]
/lib64/libpython2.7.so.1.0(PyObject_Call+0x68)[0x3ffb015afa0]
/lib64/libpython2.7.so.1.0(+0x5a500)[0x3ffb016a500]
/lib64/libpython2.7.so.1.0(PyObject_Call+0x68)[0x3ffb015afa0]
/lib64/libpython2.7.so.1.0(+0xa50b4)[0x3ffb01b50b4]
/lib64/libpython2.7.so.1.0(PyObject_Call+0x68)[0x3ffb015afa0]
/lib64/libpython2.7.so.1.0(PyEval_EvalFrameEx+0x39e8)[0x3ffb01f40c8]
/lib64/libpython2.7.so.1.0(PyEval_EvalCodeEx+0x818)[0x3ffb01f6d20]
/lib64/libpython2.7.so.1.0(+0x709bc)[0x3ffb01809bc]
/lib64/libpython2.7.so.1.0(PyObject_Call+0x68)[0x3ffb015afa0]
/lib64/libpython2.7.so.1.0(PyEval_EvalFrameEx+0xc20)[0x3ffb01f1300]
/lib64/libpython2.7.so.1.0(PyEval_EvalCodeEx+0x818)[0x3ffb01f6d20]
/lib64/libpython2.7.so.1.0(+0x708c8)[0x3ffb01808c8]
/lib64/libpython2.7.so.1.0(PyObject_Call+0x68)[0x3ffb015afa0]
/lib64/libpython2.7.so.1.0(+0x5a500)[0x3ffb016a500]
/lib64/libpython2.7.so.1.0(PyObject_Call+0x68)[0x3ffb015afa0]
/lib64/libpython2.7.so.1.0(+0xa50b4)[0x3ffb01b50b4]
/lib64/libpython2.7.so.1.0(PyObject_Call+0x68)[0x3ffb015afa0]
/lib64/libpython2.7.so.1.0(PyEval_EvalFrameEx+0x39e8)[0x3ffb01f40c8]
/lib64/libpython2.7.so.1.0(PyEval_EvalCodeEx+0x818)[0x3ffb01f6d20]
/lib64/libpython2.7.so.1.0(+0x709bc)[0x3ffb01809bc]
/lib64/libpython2.7.so.1.0(PyObject_Call+0x68)[0x3ffb015afa0]
/lib64/libpython2.7.so.1.0(PyEval_EvalFrameEx+0xc20)[0x3ffb01f1300]
/lib64/libpython2.7.so.1.0(PyEval_EvalCodeEx+0x818)[0x3ffb01f6d20]
/lib64/libpython2.7.so.1.0(+0x708c8)[0x3ffb01808c8]
/lib64/libpython2.7.so.1.0(PyObject_Call+0x68)[0x3ffb015afa0]
/lib64/libpython2.7.so.1.0(+0x5a500)[0x3ffb016a500]
/lib64/libpython2.7.so.1.0(PyObject_Call+0x68)[0x3ffb015afa0]
/lib64/libpython2.7.so.1.0(+0xa50b4)[0x3ffb01b50b4]
/lib64/libpython2.7.so.1.0(PyObject_Call+0x68)[0x3ffb015afa0]
/lib64/libpython2.7.so.1.0(PyEval_EvalFrameEx+0x39e8)[0x3ffb01f40c8]
/lib64/libpython2.7.so.1.0(PyEval_EvalFrameEx+0x5a18)[0x3ffb01f60f8]
/lib64/libpython2.7.so.1.0(PyEval_EvalFrameEx+0x5a18)[0x3ffb01f60f8]
/lib64/libpython2.7.so.1.0(PyEval_EvalFrameEx+0x5a18)[0x3ffb01f60f8]
/lib64/libpython2.7.so.1.0(PyEval_EvalFrameEx+0x5a18)[0x3ffb01f60f8]
/lib64/libpython2.7.so.1.0(PyEval_EvalCodeEx+0x818)[0x3ffb01f6d20]
/lib64/libpython2.7.so.1.0(PyEval_EvalFrameEx+0x58e0)[0x3ffb01f5fc0]
/lib64/libpython2.7.so.1.0(PyEval_EvalCodeEx+0x818)[0x3ffb01f6d20]
/lib64/libpython2.7.so.1.0(PyEval_EvalCode+0x2c)[0x3ffb01f6e34]
/lib64/libpython2.7.so.1.0(+0x100c80)[0x3ffb0210c80]
/lib64/libpython2.7.so.1.0(PyRun_FileExFlags+0x8c)[0x3ffb0211ec4]
/lib64/libpython2.7.so.1.0(PyRun_SimpleFileExFlags+0xec)[0x3ffb0213144]
======= Memory map: ========
2aad6eb0000-2aad6ec0000 r-xp 00000000 08:04 5774170                      /usr/bin/python2.7
2aad6ec0000-2aad6ed0000 r--p 00000000 08:04 5774170                      /usr/bin/python2.7
2aad6ed0000-2aad6ee0000 rw-p 00010000 08:04 5774170                      /usr/bin/python2.7
2ab0dc30000-2ab0dda0000 rw-p 00000000 00:00 0                            [heap]
3ffa8000000-3ffa8030000 rw-p 00000000 00:00 0 
3ffa8030000-3ffac000000 ---p 00000000 00:00 0 
3ffaefb0000-3ffaefd0000 r-xp 00000000 08:04 6029878                      /usr/lib64/libgcc_s-5.1.1-20150618.so.1
3ffaefd0000-3ffaefe0000 rw-p 00010000 08:04 6029878                      /usr/lib64/libgcc_s-5.1.1-20150618.so.1
3ffaeff0000-3ffaf000000 ---p 00000000 00:00 0 
3ffaf000000-3ffaf910000 rw-p 00000000 00:00 0 
3ffaf910000-3ffaf920000 r-xp 00000000 08:04 6685818                      /usr/lib64/python2.7/lib-dynload/_struct.so
3ffaf920000-3ffaf930000 r--p 00000000 08:04 6685818                      /usr/lib64/python2.7/lib-dynload/_struct.so
3ffaf930000-3ffaf940000 rw-p 00010000 08:04 6685818                      /usr/lib64/python2.7/lib-dynload/_struct.so
3ffaf940000-3ffaf950000 r-xp 00000000 08:04 6030710                      /usr/lib64/libffi.so.6.0.2
3ffaf950000-3ffaf960000 r--p 00000000 08:04 6030710                      /usr/lib64/libffi.so.6.0.2
3ffaf960000-3ffaf970000 rw-p 00010000 08:04 6030710                      /usr/lib64/libffi.so.6.0.2
3ffaf970000-3ffaf990000 r-xp 00000000 08:04 6685800                      /usr/lib64/python2.7/lib-dynload/_ctypes.so
3ffaf990000-3ffaf9a0000 r--p 00010000 08:04 6685800                      /usr/lib64/python2.7/lib-dynload/_ctypes.so
3ffaf9a0000-3ffaf9b0000 rw-p 00020000 08:04 6685800                      /usr/lib64/python2.7/lib-dynload/_ctypes.so
3ffaf9b0000-3ffaf9c0000 r-xp 00000000 08:04 6685850                      /usr/lib64/python2.7/lib-dynload/timemodule.so
3ffaf9c0000-3ffaf9d0000 r--p 00000000 08:04 6685850                      /usr/lib64/python2.7/lib-dynload/timemodule.so
3ffaf9d0000-3ffaf9e0000 rw-p 00010000 08:04 6685850                      /usr/lib64/python2.7/lib-dynload/timemodule.so
3ffaf9e0000-3ffafa20000 rw-p 00000000 00:00 0 
3ffafa20000-3ffafa30000 r-xp 00000000 08:04 6685824                      /usr/lib64/python2.7/lib-dynload/cStringIO.so
3ffafa30000-3ffafa40000 r--p 00000000 08:04 6685824                      /usr/lib64/python2.7/lib-dynload/cStringIO.so
3ffafa40000-3ffafa50000 rw-p 00010000 08:04 6685824                      /usr/lib64/python2.7/lib-dynload/cStringIO.so
3ffafa50000-3ffafa90000 rw-p 00000000 00:00 0 
3ffafa90000-3ffafaa0000 r-xp 00000000 08:04 6685804                      /usr/lib64/python2.7/lib-dynload/_functoolsmodule.so
3ffafaa0000-3ffafab0000 r--p 00000000 08:04 6685804                      /usr/lib64/python2.7/lib-dynload/_functoolsmodule.so
3ffafab0000-3ffafac0000 rw-p 00010000 08:04 6685804                      /usr/lib64/python2.7/lib-dynload/_functoolsmodule.so
3ffafac0000-3ffafad0000 r-xp 00000000 08:04 6685806                      /usr/lib64/python2.7/lib-dynload/_heapq.so
3ffafad0000-3ffafae0000 r--p 00000000 08:04 6685806                      /usr/lib64/python2.7/lib-dynload/_heapq.so
3ffafae0000-3ffafaf0000 rw-p 00010000 08:04 6685806                      /usr/lib64/python2.7/lib-dynload/_heapq.so
3ffafaf0000-3ffafb00000 r-xp 00000000 08:04 6685834                      /usr/lib64/python2.7/lib-dynload/itertoolsmodule.so
3ffafb00000-3ffafb10000 r--p 00000000 08:04 6685834                      /usr/lib64/python2.7/lib-dynload/itertoolsmodule.so
3ffafb10000-3ffafb20000 rw-p 00010000 08:04 6685834                      /usr/lib64/python2.7/lib-dynload/itertoolsmodule.so
3ffafb20000-3ffafb30000 r-xp 00000000 08:04 6685839                      /usr/lib64/python2.7/lib-dynload/operator.so
3ffafb30000-3ffafb40000 r--p 00000000 08:04 6685839                      /usr/lib64/python2.7/lib-dynload/operator.so
3ffafb40000-3ffafb50000 rw-p 00010000 08:04 6685839                      /usr/lib64/python2.7/lib-dynload/operator.so
3ffafb50000-3ffafb60000 r-xp 00000000 08:04 6685797                      /usr/lib64/python2.7/lib-dynload/_collectionsmodule.so
3ffafb60000-3ffafb70000 r--p 00000000 08:04 6685797                      /usr/lib64/python2.7/lib-dynload/_collectionsmodule.so
3ffafb70000-3ffafb80000 rw-p 00010000 08:04 6685797                      /usr/lib64/python2.7/lib-dynload/_collectionsmodule.so
3ffafb80000-3ffafbc0000 rw-p 00000000 00:00 0 
3ffafbc0000-3ffafbd0000 r-xp 00000000 08:04 6685832                      /usr/lib64/python2.7/lib-dynload/grpmodule.so
3ffafbd0000-3ffafbe0000 r--p 00000000 08:04 6685832                      /usr/lib64/python2.7/lib-dynload/grpmodule.so
3ffafbe0000-3ffafbf0000 rw-p 00010000 08:04 6685832                      /usr/lib64/python2.7/lib-dynload/grpmodule.so
3ffafbf0000-3ffafc00000 r-xp 00000000 08:04 6685847                      /usr/lib64/python2.7/lib-dynload/stropmodule.so
3ffafc00000-3ffafc10000 r--p 00000000 08:04 6685847                      /usr/lib64/python2.7/lib-dynload/stropmodule.so
3ffafc10000-3ffafc20000 rw-p 00010000 08:04 6685847                      /usr/lib64/python2.7/lib-dynload/stropmodule.so
3ffafc20000-3ffafca0000 rw-p 00000000 00:00 0 
3ffafca0000-3ffafcb0000 r-xp 00000000 08:04 6685810                      /usr/lib64/python2.7/lib-dynload/_localemodule.so
3ffafcb0000-3ffafcc0000 r--p 00000000 08:04 6685810                      /usr/lib64/python2.7/lib-dynload/_localemodule.so
3ffafcc0000-3ffafcd0000 rw-p 00010000 08:04 6685810                      /usr/lib64/python2.7/lib-dynload/_localemodule.so
3ffafcd0000-3ffafe10000 rw-p 00000000 00:00 0 
3ffafe10000-3ffaff80000 r-xp 00000000 08:04 6030499                      /usr/lib64/libc-2.22.so
3ffaff80000-3ffaff90000 r--p 00160000 08:04 6030499                      /usr/lib64/libc-2.22.so
3ffaff90000-3ffaffa0000 rw-p 00170000 08:04 6030499                      /usr/lib64/libc-2.22.so
3ffaffa0000-3ffb0050000 r-xp 00000000 08:04 6030507                      /usr/lib64/libm-2.22.so
3ffb0050000-3ffb0060000 r--p 000a0000 08:04 6030507                      /usr/lib64/libm-2.22.so
3ffb0060000-3ffb0070000 rw-p 000b0000 08:04 6030507                      /usr/lib64/libm-2.22.so
3ffb0070000-3ffb0080000 r-xp 00000000 08:04 6030533                      /usr/lib64/libutil-2.22.so
3ffb0080000-3ffb0090000 r--p 00000000 08:04 6030533                      /usr/lib64/libutil-2.22.so
3ffb0090000-3ffb00a0000 rw-p 00010000 08:04 6030533                      /usr/lib64/libutil-2.22.so
3ffb00a0000-3ffb00b0000 r-xp 00000000 08:04 6030505                      /usr/lib64/libdl-2.22.so
3ffb00b0000-3ffb00c0000 r--p 00000000 08:04 6030505                      /usr/lib64/libdl-2.22.so
3ffb00c0000-3ffb00d0000 rw-p 00010000 08:04 6030505                      /usr/lib64/libdl-2.22.so
3ffb00d0000-3ffb00f0000 r-xp 00000000 08:04 6030525                      /usr/lib64/libpthread-2.22.so
3ffb00f0000-3ffb0100000 r--p 00010000 08:04 6030525                      /usr/lib64/libpthread-2.22.so
3ffb0100000-3ffb0110000 rw-p 00020000 08:04 6030525                      /usr/lib64/libpthread-2.22.so
3ffb0110000-3ffb02a0000 r-xp 00000000 08:04 6032178                      /usr/lib64/libpython2.7.so.1.0
3ffb02a0000-3ffb02b0000 r--p 00180000 08:04 6032178                      /usr/lib64/libpython2.7.so.1.0
3ffb02b0000-3ffb02f0000 rw-p 00190000 08:04 6032178                      /usr/lib64/libpython2.7.so.1.0
3ffb02f0000-3ffb0310000 rw-p 00000000 00:00 0 
3ffb0310000-3ffb0320000 r--p 00000000 00:00 0                            [vvar]
3ffb0320000-3ffb0330000 r-xp 00000000 00:00 0                            [vdso]
3ffb0330000-3ffb0350000 r-xp 00000000 08:04 6030492                      /usr/lib64/ld-2.22.so
3ffb0350000-3ffb0360000 r--p 00010000 08:04 6030492                      /usr/lib64/ld-2.22.so
3ffb0360000-3ffb0370000 rw-p 00020000 08:04 6030492                      /usr/lib64/ld-2.22.so
3ffdd7c0000-3ffdd7f0000 rw-p 00000000 00:00 0                            [stack]
Comment 1 Fedora Admin XMLRPC Client 2016-01-29 08:04:19 EST
This package has changed ownership in the Fedora Package Database.  Reassigning to the new owner of this component.
Comment 2 Jan Kurik 2016-02-24 09:06:50 EST
This bug appears to have been reported against 'rawhide' during the Fedora 24 development cycle.
Changing version to '24'.

More information and reason for this action is here:
https://fedoraproject.org/wiki/Fedora_Program_Management/HouseKeeping/Fedora24#Rawhide_Rebase
Comment 3 Charalampos Stratakis 2016-05-30 09:05:23 EDT
By doing a scratch build [0] I don't see the tests failing. Is there some other way you invoke the tests on the specific arch?

[0]: http://koji.fedoraproject.org/koji/taskinfo?taskID=14312178
Comment 4 Yaakov Selkowitz 2016-05-30 11:20:47 EDT
(In reply to Charalampos Stratakis from comment #3)
> By doing a scratch build [0] I don't see the tests failing.

That build was done on armhfp, not aarch64.

> Is there some other way you invoke the tests on the specific arch?

In Fedora, aarch64 has its own koji instance, therefore:

fedpkg srpm
arm-koji build --scratch f24 ./python-pthreading-0.1.3-5.fc25.src.rpm
Comment 5 jack 2016-07-05 02:18:06 EDT
Does this bug mean that we could not use python-pthreading on aarch64?
Comment 6 Petr Viktorin 2016-07-05 04:07:46 EDT
Since pthreading uses ctypes and monkeypatches the standard library, I don't think "no architecture-specific code in python-pthreading" is a good reason to automatically blame Python.

Can you prepare a minimal reproducer?
Comment 7 Yaakov Selkowitz 2017-03-17 16:58:00 EDT
I wonder if https://bugs.python.org/issue29804 might be related?
Comment 8 Fedora End Of Life 2017-07-25 15:36:40 EDT
This message is a reminder that Fedora 24 is nearing its end of life.
Approximately 2 (two) weeks from now Fedora will stop maintaining
and issuing updates for Fedora 24. It is Fedora's policy to close all
bug reports from releases that are no longer maintained. At that time
this bug will be closed as EOL if it remains open with a Fedora  'version'
of '24'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version'
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not
able to fix it before Fedora 24 is end of life. If you would still like
to see this bug fixed and are able to reproduce it against a later version
of Fedora, you are encouraged  change the 'version' to a later Fedora
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's
lifetime, sometimes those efforts are overtaken by events. Often a
more recent Fedora release includes newer upstream software that fixes
bugs or makes them obsolete.
Comment 9 Jan Kurik 2017-08-15 04:29:54 EDT
This bug appears to have been reported against 'rawhide' during the Fedora 27 development cycle.
Changing version to '27'.
Comment 10 Yaakov Selkowitz 2018-03-20 23:11:34 EDT
(In reply to Petr Viktorin from comment #6)
> Since pthreading uses ctypes and monkeypatches the standard library, I don't
> think "no architecture-specific code in python-pthreading" is a good reason
> to automatically blame Python.

Something in userspace changed must have changed in F27, because now the tests pass there but not in F26 or RHEL 7.  Whether it is python or libffi has yet TBD, but it's clearly not python-pthreading.

Note You need to log in before you can comment on or make changes to this bug.